/*!
 *  @preserve
 *  
 *  @module      iframe-resizer/child 5.4.6 (iife) 
 *
 *  @license     GPL-3.0 for non-commercial use only.
 *               For commercial use, you must purchase a license from
 *               https://iframe-resizer.com/pricing
 * 
 *  @description Keep same and cross domain iFrames sized to their content 
 *
 *  @author      David J. Bradshaw <info@iframe-resizer.com>
 * 
 *  @see         {@link https://iframe-resizer.com}
 * 
 *  @copyright  (c) 2013 - 2025, David J. Bradshaw. All rights reserved.
 */


!function(){"use strict";const e="font-weight: normal;",t="font-weight: bold;",n="font-style: italic;",o=e+n,r="default",i=Object.freeze({assert:!0,error:!0,warn:!0}),a={expand:!0,defaultEvent:void 0,event:void 0,label:"AutoConsoleGroup",showTime:!0},s={profile:0,profileEnd:0,timeStamp:0,trace:0},l=Object.assign(console);const{fromEntries:c,keys:u}=Object,d=e=>[e,l[e]],f=e=>t=>[t,function(n){e[t]=n}],m=(e,t)=>c(u(e).map(t));const p=!(typeof window>"u"||"function"!=typeof window.matchMedia)&&window.matchMedia("(prefers-color-scheme: dark)").matches,h=p?"color: #A9C7FB;":"color: #135CD2;",g=p?"color: #E3E3E3;":"color: #1F1F1F;",y="5.4.6",b=10,v="data-iframe-size",z="data-iframe-overflowed",w="data-iframe-ignore",$="bottom",S="right",E="autoResizeEnabled",O=Symbol("sizeChanged"),j="manualResize",k="parentResize",M={[j]:1,[k]:1},T="setOffsetSize",C="resizeObserver",P="overflowObserver",A="mutationObserver",I="init",x=(e,t,n,o)=>e.addEventListener(t,n,o||!1),N=(e,t,n)=>e.removeEventListener(t,n,!1),R=["<iy><yi>Puchspk Spjluzl Rlf</><iy><iy>","<iy><yi>Tpzzpun Spjluzl Rlf</><iy><iy>","Aopz spiyhyf pz hchpshisl dpao ivao Jvttlyjphs huk Vwlu-Zvbyjl spjluzlz.<iy><iy><i>Jvttlyjphs Spjluzl</><iy>Mvy jvttlyjphs bzl, <p>pmyhtl-ylzpgly</> ylxbpylz h svd jvza vul aptl spjluzl mll. Mvy tvyl pumvythapvu cpzpa <b>oaawz://pmyhtl-ylzpgly.jvt/wypjpun</>.<iy><iy><i>Vwlu Zvbyjl Spjluzl</><iy>Pm fvb hyl bzpun aopz spiyhyf pu h uvu-jvttlyjphs vwlu zvbyjl wyvqlja aolu fvb jhu bzl pa mvy myll bukly aol alytz vm aol NWS C3 Spjluzl. Av jvumpyt fvb hjjlwa aolzl alytz, wslhzl zla aol <i>spjluzl</> rlf pu <p>pmyhtl-ylzpgly</> vwapvuz av <i>NWSc3</>.<iy><iy>Mvy tvyl pumvythapvu wslhzl zll: <b>oaawz://pmyhtl-ylzpgly.jvt/nws</>","<i>NWSc3 Spjluzl Clyzpvu</><iy><iy>Aopz clyzpvu vm <p>pmyhtl-ylzpgly</> pz ilpun bzlk bukly aol alytz vm aol <i>NWS C3</> spjluzl. Aopz spjluzl hssvdz fvb av bzl <p>pmyhtl-ylzpgly</> pu Vwlu Zvbyjl wyvqljaz, iba pa ylxbpylz fvby wyvqlja av il wbispj, wyvcpkl haaypibapvu huk il spjluzlk bukly clyzpvu 3 vy shaly vm aol NUB Nlulyhs Wbispj Spjluzl.<iy><iy>Pm fvb hyl bzpun aopz spiyhyf pu h uvu-vwlu zvbyjl wyvqlja vy dlizpal, fvb dpss ullk av wbyjohzl h svd jvza vul aptl jvttlyjphs spjluzl.<iy><iy>Mvy tvyl pumvythapvu cpzpa <b>oaawz://pmyhtl-ylzpgly.jvt/wypjpun</>.","<iy><yi>Zvsv spjluzl kvlz uva zbwwvya jyvzz-kvthpu</><iy><iy>Av bzl <p>pmyhtl-ylzpgly</> dpao jyvzz kvthpu pmyhtlz fvb ullk lpaoly aol Wyvmlzzpvuhs vy Ibzpulzz spjluzlz. Mvy klahpsz vu bwnyhkl wypjpun wslhzl jvuahja pumv@pmyhtl-ylzpgly.jvt."];Object.fromEntries(["2cgs7fdf4xb","1c9ctcccr4z","1q2pc4eebgb","ueokt0969w","w2zxchhgqz","1umuxblj2e5"].map(((e,t)=>[e,Math.max(0,t-1)])));const B=e=>(e=>e.replace(/[A-Za-z]/g,(e=>String.fromCodePoint((e<="Z"?90:122)>=(e=e.codePointAt(0)+19)?e:e-26))))(R[e]),q=e=>{let t=!1;return function(){return t?void 0:(t=!0,Reflect.apply(e,this,arguments))}},L=e=>e,F=e=>Math.round(1e3*e)/1e3,W=e=>e.charAt(0).toUpperCase()+e.slice(1),D=e=>""!=`${e}`&&void 0!==e;const H=(e,t,n)=>{if(typeof e!==t)throw new TypeError(`${n} is not a ${W(t)}`)};let V=!0;const U=(Z=function(n={}){const c={},u={},p=[],h={...a,expand:!n.collapsed||a.expanded,...n};let g="";function y(){p.length=0,g=""}function b(){delete h.event,y()}const v=()=>!!p.some((([e])=>e in i))||!!h.expand;function z(){if(0!==p.length){l[v()?"group":"groupCollapsed"](`%c${h.label}%c ${(e=>{const t=e.event||e.defaultEvent;return t?`${t}`:""})(h)} %c${h.showTime?g:""}`,e,t,o);for(const[e,...t]of p)l.assert(e in l,`Unknown console method: ${e}`),e in l&&l[e](...t);l.groupEnd(),b()}else b()}function w(){""===g&&(g=function(){const e=new Date,t=(t,n)=>e[t]().toString().padStart(n,"0");return`@ ${t("getHours",2)}:${t("getMinutes",2)}:${t("getSeconds",2)}.${t("getMilliseconds",3)}`}())}function $(e,...t){0===p.length&&(w(),queueMicrotask((()=>queueMicrotask(z)))),p.push([e,...t])}function S(e=r,...t){c[e]?$("log",`${e}: ${performance.now()-c[e]} ms`,...t):$("timeLog",e,...t)}return{...m(h,f(h)),...m(console,(e=>[e,(...t)=>$(e,...t)])),...m(s,d),assert:function(e,...t){e||$("assert",e,...t)},count:function(e=r){u[e]?u[e]+=1:u[e]=1,$("log",`${e}: ${u[e]}`)},countReset:function(e=r){delete u[e]},endAutoGroup:z,errorBoundary:e=>(...t)=>{let n;try{n=e(...t)}catch(e){if(!Error.prototype.isPrototypeOf(e))throw e;$("error",e)}return n},event:function(e){w(),h.event=e},purge:y,time:function(e=r){w(),c[e]=performance.now()},timeEnd:function(e=r){S(e),delete c[e]},timeLog:S,touch:w}},Z?.__esModule?Z.default:Z);var Z;const J=U({label:"iframeResizer(child)"});var _;const Q=(_="log",(...e)=>!V||J[_](...e)),{assert:G,debug:X,endAutoGroup:Y,error:K,errorBoundary:ee,event:te,label:ne,purge:oe,warn:re}=J,ie=e=>{return J.warn((t=L,e=>window.chrome?t(e.replaceAll("<br>","\n").replaceAll("<rb>","[31;1m").replaceAll("</>","[m").replaceAll("<b>","[1m").replaceAll("<i>","[3m").replaceAll("<u>","[4m")):t(e.replaceAll("<br>","\n").replaceAll(/<[/a-z]+>/gi,"")))(e));var t},ae=ie,se=(e=>(t,n="renamed to")=>(o,r,i="",a="")=>e(a,`<rb>Deprecated ${t}(${o.replace("()","")})</>\n\nThe <b>${o}</> ${t.toLowerCase()} has been ${n} <b>${r}</>. ${i}Use of the old ${t.toLowerCase()} will be removed in a future version of <i>iframe-resizer</>.`))(((e,t)=>ie(t))),le=se("Method"),ce=se("Method","replaced with"),ue=se("Option"),de=e=>t=>void 0===t?void 0:e(t),fe=de((e=>"true"===e)),me=de(Number),pe="--ifr-start",he="--ifr-end",ge=[],ye=new WeakSet,be=e=>"object"==typeof e&&ye.add(e);let ve={},ze=0;const we=setInterval((()=>{if(ge.length<10)return;if(ve.hasTags&&ve.len<25)return;ge.sort();const e=Math.min(ge.reduce(((e,t)=>e+t),0)/ge.length,ge[Math.floor(ge.length/2)]),t=F(e);t>ze&&(ze=t,te("performanceObserver")),e<=4||(clearInterval(we),ie(`<rb>Performance Warning</>\n\nCalculating the page size is taking an excessive amount of time (${F(e)}ms).\n\nTo improve performance add the <b>data-iframe-size</> attribute to the ${ve.Side.toLowerCase()} most element on the page. For more details see: <u>https://iframe-resizer.com/perf</>.`))}),5e3);function $e(e){e.getEntries().forEach((e=>{if(e.name===he){const{duration:t}=performance.measure("--ifr-measure",pe,he);ve=e.detail,ge.push(t),ge.length>100&&ge.shift()}}))}function Se(){new PerformanceObserver($e).observe({entryTypes:["mark"]}),be(document.documentElement),be(document.body)}"undefined"!=typeof document&&"undefined"!=typeof PerformanceObserver&&("loading"===document.readyState?document.addEventListener("DOMContentLoaded",Se):Se());const Ee=e=>(t,n)=>{if(n in t){if(typeof t[n]===e)return t[n];throw new TypeError(`${n} is not a ${e}.`)}},Oe=Ee("function"),je=Ee("number"),ke=Ee("string");"undefined"!=typeof window&&function(){const o={contentVisibilityAuto:!0,opacityProperty:!0,visibilityProperty:!0},r={height:()=>(re("Custom height calculation function not defined"),wt.auto()),width:()=>(re("Custom width calculation function not defined"),$t.auto())},i={bodyOffset:1,bodyScroll:1,offset:1,documentElementOffset:1,documentElementScroll:1,boundingClientRect:1,max:1,min:1,grow:1,lowestElement:1},a={},s="checkVisibility"in window,l="auto",c="[iFrameSizer]",u="scroll";let d,f,m,p,R,F=!0,U="",Z=0,_="",X="",K=!0,se=!1,de=!0,ge=!1,ye=!1,be=!1,ve=1,ze=l,we="",$e=!0,Se={},Ee=!0,Me=!1,Te="",Ce=0,Pe=!1,Ae="",Ie=L,xe=[],Ne="child",Re=null,Be=!1,qe="",Le=[],Fe=window.parent,We="*",De=0,He=!1,Ve=1,Ue=u,Ze=window,Je=()=>{re("onMessage function not defined")},_e=()=>{},Qe=null,Ge=null;function Xe(e){var t,n,o;!function(e){Ae=e[0]??Ae,Z=me(e[1])??Z,se=fe(e[2])??se,Me=fe(e[3])??Me,F=fe(e[6])??F,_=e[7]??_,ze=e[8]??ze,U=e[9]??U,X=e[10]??X,De=me(e[11])??De,Se.enable=fe(e[12])??!1,Ne=e[13]??Ne,Ue=e[14]??Ue,Pe=fe(e[15])??Pe,d=me(e[16])??d,f=me(e[17])??f,K=fe(e[18])??K,Te=e[19]??Te,p=e[20]??p,Ce=me(e[21])??Ce,Ee=fe(e[23])??Ee}(e),t={id:Ae,enabled:Me,expand:Ee},J.label(`${t.id}`),J.expand(t.expand),V=t.enabled,function(){function e(e){R=Oe(e,"onBeforeResize")??R,Je=Oe(e,"onMessage")??Je,_e=Oe(e,"onReady")??_e,"number"==typeof e?.offset&&(ue("offset","offsetSize"),K&&(d=je(e,"offset")??d),se&&(f=je(e,"offset")??f)),"number"==typeof e?.offsetSize&&(K&&(d=je(e,"offsetSize")??d),se&&(f=je(e,"offsetSize")??f)),we=ke(e,"ignoreSelector")??we,qe=ke(e,"sizeSelector")??qe,We=ke(e,"targetOrigin")??We,ze=e?.heightCalculationMethod||ze,Ue=e?.widthCalculationMethod||Ue}function t(e,t){return"function"==typeof e&&(ie(`<rb>Deprecated Option(${t}CalculationMethod)</>\n\nThe use of <b>${t}CalculationMethod</> as a function is deprecated and will be removed in a future version of <i>iframe-resizer</>. Please use the new <b>onBeforeResize</> event handler instead.\n\nSee <u>https://iframe-resizer.com/api/child</> for more details.`),r[t]=e,e="custom"),e}if(1===Ce)return;const n=window.iframeResizer||window.iFrameResizer;"object"==typeof n&&(e(n),ze=t(ze,"height"),Ue=t(Ue,"width"),Q(`Set targetOrigin for parent: %c${We}`,h))}(),at(),function(){try{Be=1===Ce||"iframeParentListener"in window.parent}catch(e){}}(),Ce<0?ae(`${B(Ce+2)}${B(2)}`):p?.codePointAt(0)>4||Ce<2&&ae(B(3)),p&&""!==p&&"false"!==p?p!==y&&ie(`<b>Version mismatch</>\n\nThe parent and child pages are running different versions of <i>iframe resizer</>.\n\nParent page: ${p} - Child page: ${y}.\n`):ie("<rb>Legacy version detected on parent page</>\n\nDetected legacy version of parent page script. It is recommended to update the parent page to use <b>@iframe-resizer/parent</>.\n\nSee <u>https://iframe-resizer.com/setup/</> for more details.\n"),ct(),ut(),function(){let e=!1;const t=t=>document.querySelectorAll(`[${t}]`).forEach((n=>{e=!0,n.removeAttribute(t),n.toggleAttribute(v,!0)}));t("data-iframe-height"),t("data-iframe-width"),e&&ie("<rb>Deprecated Attributes</>\n          \nThe <b>data-iframe-height</> and <b>data-iframe-width</> attributes have been deprecated and replaced with the single <b>data-iframe-size</> attribute. Use of the old attributes will be removed in a future version of <i>iframe-resizer</>.")}(),"BackCompat"===document.compatMode&&ie("<rb>Quirks Mode Detected</>\n\nThis iframe is running in the browser's legacy <b>Quirks Mode</>, this may cause issues with the correct operation of <i>iframe-resizer</>. It is recommended that you switch to the modern <b>Standards Mode</>.\n\nFor more information see <u>https://iframe-resizer.com/quirks-mode</>.\n"),et(),1!==Ce&&(Ze.parentIframe=Object.freeze({autoResize:e=>(H(e,"boolean","parentIframe.autoResize(enable) enable"),!1===se&&!1===K?(te(E),ie("Auto Resize can not be changed when <b>direction</> is set to 'none'."),!1):(!0===e&&!1===F?(F=!0,queueMicrotask((()=>kt(E,"Auto Resize enabled")))):!1===e&&!0===F&&(F=!1),Tt(0,0,"autoResize",JSON.stringify(F)),F)),close(){Tt(0,0,"close")},getId:()=>Ae,getOrigin:()=>(le("getOrigin()","getParentOrigin()"),m),getParentOrigin:()=>m,getPageInfo(e){if("function"==typeof e)return Qe=e,Tt(0,0,"pageInfo"),void ce("getPageInfo()","getParentProps()","See <u>https://iframe-resizer.com/upgrade</> for details. ");Qe=null,Tt(0,0,"pageInfoStop")},getParentProps:e=>(H(e,"function","parentIframe.getParentProps(callback) callback"),Ge=e,Tt(0,0,"parentInfo"),()=>{Ge=null,Tt(0,0,"parentInfoStop")}),getParentProperties(e){le("getParentProperties()","getParentProps()"),this.getParentProps(e)},moveToAnchor(e){H(e,"string","parentIframe.moveToAnchor(anchor) anchor"),Se.findTarget(e)},reset(){!function(){const e=ze;ze=l,He||(He=!0,requestAnimationFrame((()=>{He=!1}))),Mt("reset"),ze=e}()},setOffsetSize(e){H(e,"number","parentIframe.setOffsetSize(offset) offset"),d=e,f=e,kt(T,`parentIframe.setOffsetSize(${e})`)},scrollBy(e,t){H(e,"number","parentIframe.scrollBy(x, y) x"),H(t,"number","parentIframe.scrollBy(x, y) y"),Tt(t,e,"scrollBy")},scrollTo(e,t){H(e,"number","parentIframe.scrollTo(x, y) x"),H(t,"number","parentIframe.scrollTo(x, y) y"),Tt(t,e,"scrollTo")},scrollToOffset(e,t){H(e,"number","parentIframe.scrollToOffset(x, y) x"),H(t,"number","parentIframe.scrollToOffset(x, y) y"),Tt(t,e,"scrollToOffset")},sendMessage(e,t){t&&H(t,"string","parentIframe.sendMessage(msg, targetOrigin) targetOrigin"),Tt(0,0,"message",JSON.stringify(e),t)},setHeightCalculationMethod(e){ze=e,ct()},setWidthCalculationMethod(e){Ue=e,ut()},setTargetOrigin(e){H(e,"string","parentIframe.setTargetOrigin(targetOrigin) targetOrigin"),We=e},resize(e,t){e&&H(e,"number","parentIframe.resize(customHeight, customWidth) customHeight"),t&&H(t,"number","parentIframe.resize(customHeight, customWidth) customWidth"),kt(j,`parentIframe.resize(${e||""}${t?`,${t}`:""})`,e,t)},size(e,t){le("size()","resize()"),this.resize(e,t)}}),Ze.parentIFrame=Ze.parentIframe),function(){function e(e){Tt(0,0,e.type,`${e.screenY}:${e.screenX}`)}function t(t,n){x(window.document,t,e)}!0===Pe&&(t("mouseenter"),t("mouseleave"))}(),Se=function(){const e=()=>({x:document.documentElement.scrollLeft,y:document.documentElement.scrollTop});function t(t){const n=t.getBoundingClientRect(),o=e();return{x:parseInt(n.left,b)+parseInt(o.x,b),y:parseInt(n.top,b)+parseInt(o.y,b)}}function n(e){function n(e){const n=t(e);Tt(n.y,n.x,"scrollToOffset")}const o=e.split("#")[1]||e,r=decodeURIComponent(o),i=document.getElementById(r)||document.getElementsByName(r)[0];void 0===i?Tt(0,0,"inPageLink",`#${o}`):n(i)}function o(){const{hash:e,href:t}=window.location;""!==e&&"#"!==e&&n(t)}function r(){for(const e of document.querySelectorAll('a[href^="#"]'))"#"!==e.getAttribute("href")&&x(e,"click",(t=>{t.preventDefault(),n(e.getAttribute("href"))}))}function i(){x(window,"hashchange",o)}function a(){setTimeout(o,128)}function s(){r(),i(),a()}return Se.enable&&(1===Ce?ie("In page linking requires a Professional or Business license. Please see <u>https://iframe-resizer.com/pricing</> for more details."):s()),{findTarget:n}}(),void 0===_&&(_=`${Z}px`),rt("margin",(n="margin",(o=_).includes("-")&&(re(`Negative CSS value ignored for ${n}`),o=""),o)),rt("background",U),rt("padding",X),function(){const e=document.createElement("div");e.style.clear="both",e.style.display="block",e.style.height="0",document.body.append(e)}(),function(){const e=e=>e.style.setProperty("height","auto","important");e(document.documentElement),e(document.body)}(),function(e){st({method:e,eventType:"After Print",eventName:"afterprint"}),st({method:e,eventType:"Before Print",eventName:"beforeprint"}),st({method:e,eventType:"Ready State Change",eventName:"readystatechange"})}("add"),function(){const e=new Set,t=[];let n=!1,o=0;const r=t=>{Q("Mutations observed:",t);for(const n of t){const{addedNodes:t,removedNodes:o}=n;for(const n of t)e.add(n);for(const t of o)e.delete(t)}},i=16,a=2,s=200;let l=1;function c(e){at(),tt(e),e.forEach(mt),e.clear()}function u(){const d=performance.now(),f=d-o;if(f>i*l+++a&&f<s)return Q("Backed off due to heavy workload on callStack"),setTimeout(u,i*l),void(o=d);l=1,t.forEach(r),t.length=0,e.size>0&&c(e),et(),Ye(),n=!1,kt(A,"Mutation Observed")}function d(e){t.push(e),n||(o=performance.now(),n=!0,requestAnimationFrame(u))}function f(){const e=new window.MutationObserver(d),t=document.querySelector("body"),n={attributes:!0,attributeFilter:[w,v],attributeOldValue:!1,characterData:!1,characterDataOldValue:!1,childList:!0,subtree:!0};return e.observe(t,n),e}f()}(),Re=new ResizeObserver(dt),Re.observe(document.body),ft.add(document.body),mt(document.body),K!==se&&(Ie=(e=>{const t=e.side||$,n=e.onChange||L,o={root:e.root,rootMargin:"0px",threshold:1},r=window?.requestAnimationFrame||L,i=(e=!1)=>n(e),a=(e,n)=>0===e||e>n[t],s=(e,t)=>e.toggleAttribute(z,t),l=new IntersectionObserver((function(e){for(const o of e){const{boundingClientRect:e,rootBounds:r,target:i}=o,l=e[t],c=a(l,r)&&!((n=i).hidden||null===n.offsetParent||"none"===n.style.display);s(i,c)}var n;r(i)}),o),c=new WeakSet;return function(e){for(const t of e){const e=t.nodeType===Node.ELEMENT_NODE,n=c.has(t);!n&&e?(l.observe(t),c.add(t)):G(!n,"Node already observed",t)}}})({onChange:Ke,root:document.documentElement,side:K?$:S})),tt(gt(document)()),queueMicrotask(_e),kt(I,"Init message from host page",void 0,void 0,y),document.title&&""!==document.title&&Tt(0,0,"title",document.title)}function Ye(){xe=document.querySelectorAll(`[${z}]:not([${w}]):not([${w}] *)`),ye=xe.length>0}function Ke(e){Ye(),(ye||e)&&(ye?Q("Overflowed Elements:",...xe):Q("Overflow removed"),kt(P,"Overflow updated"))}function et(){Le=document.querySelectorAll(`[${v}]`),be=Le.length>0}function tt(e){be||Ie(e)}let nt=0;function ot(){const n=document.querySelectorAll(`*[${w}]`);ge=n.length>0,ge&&n.length!==nt&&(function(n){const o=1===n.length?"":"s";re(`%c[${w}]%c found on %c${n.length}%c element${o}`,t,e,t,e)}(n),nt=n.length)}function rt(e,t){void 0!==t&&""!==t&&"null"!==t&&(document.body.style.setProperty(e,t),Q(`Set body ${e}: %c${t}`,h))}function it(e,t,n){if(""!==n)for(const e of document.querySelectorAll(n))e.toggleAttribute(t,!0)}function at(){it(0,v,qe),it(0,w,we)}function st(e){({add(t){function n(){kt(e.eventName,e.eventType)}a[t]=n,x(window,t,n,{passive:!0})},remove(e){const t=a[e];delete a[e],N(window,e,t)}})[e.method](e.eventName)}function lt(e,t,n,o){return t!==e&&(e in n||(re(`${e} is not a valid option for ${o}CalculationMethod.`),e=t),e in i)&&ie(`<rb>Deprecated ${o}CalculationMethod (${e})</>\n\nThis version of <i>iframe-resizer</> can auto detect the most suitable ${o} calculation method. It is recommended that you ${p?"remove this option.":"set this option to <b>'auto'</> when using an older version of <i>iframe-resizer</> on the parent page."}`),e}function ct(){ze=lt(ze,l,wt,"height")}function ut(){Ue=lt(Ue,u,$t,"width")}function dt(e){if(!Array.isArray(e)||0===e.length)return;const t=e[0].target;kt(C,`Element resized <${function(e){switch(!0){case!D(e):return"";case D(e.id):return`${e.nodeName}#${e.id}`;case D(e.name):return`${e.nodeName} (${e.name}`;case D(e.className):return`${e.nodeName}.${e.className}`;default:return e.nodeName}}(t)}>`)}const ft=new WeakSet;function mt(e){if(e.nodeType!==Node.ELEMENT_NODE)return;if(!ft.has(e)){const t=getComputedStyle(e)?.position;""!==t&&"static"!==t&&(Re.observe(e),ft.add(e))}const t=gt(e)();for(const e of t){if(ft.has(e)||e?.nodeType!==Node.ELEMENT_NODE)continue;const t=getComputedStyle(e)?.position;""!==t&&"static"!==t&&(Re.observe(e),ft.add(e))}}function pt(e){performance.mark(pe);const t=W(e);let n=0,r=document.documentElement,i=be?0:document.documentElement.getBoundingClientRect().bottom;const a=be?Le:ye?xe:gt(document)();let l=a.length;for(const t of a)be||!s||t.checkVisibility(o)?(n=t.getBoundingClientRect()[e]+parseFloat(getComputedStyle(t).getPropertyValue(`margin-${e}`)),n>i&&(i=n,r=t)):l-=1;return Q(`${t} position calculated from:`,r),performance.mark(he,{detail:{Side:t,len:l,hasTags:be,logging:Me}}),i}const ht=e=>[e.bodyOffset(),e.bodyScroll(),e.documentElementOffset(),e.documentElementScroll(),e.boundingClientRect()],gt=e=>()=>{ot();const t=["* ","not(head)","not(meta)","not(base)","not(title)","not(script)","not(link)","not(style)","not(map)","not(area)","not(option)","not(optgroup)","not(template)","not(track)","not(wbr)","not(nobr)"];return ge&&t.push(`not([${w}])`,`not([${w}] *)`),e.querySelectorAll(t.join(":"))},yt={height:0,width:0},bt={height:0,width:0},vt=[h,g,h];function zt(e){function t(){return bt[o]=r,yt[o]=s,r}const n=e===wt,o=n?"height":"width",r=e.boundingClientRect(),i=Math.ceil(r),a=Math.floor(r),s=(e=>e.documentElementScroll()+Math.max(0,e.getOffset()))(e),l=`HTML: %c${r}px %cPage: %c${s}px`;let c=0;switch(!0){case!e.enabled():return s;case be:Q("Found element with data-iframe-size attribute"),c=e.taggedElement();break;case!ye&&0===bt[o]&&0===yt[o]:Q(`Initial page size values: ${l}`,...vt),c=t();break;case He&&r===bt[o]&&s===yt[o]:Q(`Size unchanged: ${l}`,...vt),c=Math.max(r,s);break;case 0===r:Q(`Page is hidden: ${l}`,...vt),c=s;break;case!ye&&r!==bt[o]&&s<=yt[o]:Q(`New <html> size: ${l} `,...vt),Q(`Previous <html> size: %c${bt[o]}px`,h),c=t();break;case!n:c=e.taggedElement();break;case!ye&&r<bt[o]:Q(`<html> size decreased: ${l}`,...vt),c=t();break;case s===a||s===i:Q(`<html> size equals page size: ${l}`,...vt),c=t();break;case r>s:Q(`Page size < <html> size: ${l}`,...vt),c=t();break;case ye:Q("Found element overflowing <html> "),c=e.taggedElement();break;default:Q(`Using <html> size: ${l}`,...vt),c=t()}return Q(`Content ${o}: %c${c}px`,h),c+=function(e){const t=e.getOffset();return 0!==t&&Q(`Page offsetSize: %c${t}px`,h),t}(e),c}const wt={enabled:()=>K,getOffset:()=>d,auto:()=>zt(wt),bodyOffset:()=>{const{body:e}=document,t=getComputedStyle(e);return e.offsetHeight+parseInt(t.marginTop,b)+parseInt(t.marginBottom,b)},bodyScroll:()=>document.body.scrollHeight,offset:()=>wt.bodyOffset(),custom:()=>r.height(),documentElementOffset:()=>document.documentElement.offsetHeight,documentElementScroll:()=>document.documentElement.scrollHeight,boundingClientRect:()=>Math.max(document.documentElement.getBoundingClientRect().bottom,document.body.getBoundingClientRect().bottom),max:()=>Math.max(...ht(wt)),min:()=>Math.min(...ht(wt)),grow:()=>wt.max(),lowestElement:()=>pt($),taggedElement:()=>pt($)},$t={enabled:()=>se,getOffset:()=>f,auto:()=>zt($t),bodyScroll:()=>document.body.scrollWidth,bodyOffset:()=>document.body.offsetWidth,custom:()=>r.width(),documentElementScroll:()=>document.documentElement.scrollWidth,documentElementOffset:()=>document.documentElement.offsetWidth,boundingClientRect:()=>Math.max(document.documentElement.getBoundingClientRect().right,document.body.getBoundingClientRect().right),max:()=>Math.max(...ht($t)),min:()=>Math.min(...ht($t)),rightMostElement:()=>pt(S),scroll:()=>Math.max($t.bodyScroll(),$t.documentElementScroll()),taggedElement:()=>pt(S)},St=(e,t)=>!(Math.abs(e-t)<=De);function Et(e,t){const n=e[t]();return e.enabled()&&void 0!==R?function(e){const t=R(e);if(void 0===t)throw new TypeError("No value returned from onBeforeResize(), expected a numeric value");if(Number.isNaN(t))throw new TypeError(`Invalid value returned from onBeforeResize(): ${t}, expected Number`);return t}(n):n}let Ot=!1;const jt=q((()=>ae(B(4)))),kt=ee(((e,t,n,o,r)=>{if(performance.now(),te(e),!0!==Ot)return F||e in M?void(document.hidden||(Ot=!0,requestAnimationFrame((()=>{Ot=!1})),function(e,t,n,o,r){const i=n??Et(wt,ze),a=o??Et($t,Ue);switch(K&&St(ve,i)||se&&St(Ve,a)?O:e){case I:case E:case O:ve=i,Ve=a;case T:Tt(ve,Ve,e,r);break;case C:case P:case A:oe();break;default:oe(),Q("No change in content size detected")}}(e,0,n,o,r))):(Q("Resizing disabled"),void Y())}));function Mt(e){ve=wt[ze](),Ve=$t[Ue](),Tt(ve,Ve,e)}const Tt=ee((function(e,t,o,r,i){Ce<-1||(te(o),void 0!==i||(i=We),function(){const a=`${Ae}:${e}:${t}:${o}${void 0===r?"":`:${r}`}`;if(Be)try{window.parent.iframeParentListener(c+a)}catch(e){if(1!==Ce)throw e;return void jt()}else Fe.postMessage(c+a,i);Q(`Sending message to parent page via ${Be?"sameOrigin":"postMessage"}: %c%c${a}`,n,h)}(),Y())})),Ct=ee((function(e){te("onMessage");const{freeze:t}=Object,{parse:n}=JSON,o=e=>Tt(0,0,`${e}Stop`),r={init:function(){if("loading"===document.readyState)return;const t=e.data.slice(13).split(":");Fe=e.source,m=e.origin,Xe(t),de=!1,setTimeout((()=>{$e=!1}),128)},reset(){$e||Mt("resetPage")},resize(){kt(k,"Parent window requested size check")},moveToAnchor(){Se.findTarget(a())},inPageLink(){this.moveToAnchor()},pageInfo(){const e=a();Qe?setTimeout((()=>Qe(n(e)))):o("pageInfo")},parentInfo(){const e=(r=a(),t(n(r)));var r;Ge?setTimeout((()=>Ge(e))):o("parentInfo")},message(){const e=a();setTimeout((()=>Je(n(e))))}},i=()=>e.data.split("]")[1].split(":")[0],a=()=>e.data.slice(e.data.indexOf(":")+1),s=()=>e.data.split(":")[2]in{true:1,false:1};function l(){const t=i();te(t),t in r?r[t]():"iframeResize"in window||void 0!==window.jQuery&&""in window.jQuery.prototype||s()||re(`Unexpected message (${e.data})`)}c===`${e.data}`.slice(0,13)&&function(){if(!1!==de)return s()?(ne(i()),te(I),void r.init()):void 0;l()}()}));function Pt(){"loading"!==document.readyState&&window.parent.postMessage("[iFrameResizerChild]Ready","*")}function At(e){return Ct(e),Ze}"iframeChildListener"in window?re("Already setup"):(window.iframeChildListener=e=>setTimeout((()=>Ct({data:e,sameOrigin:!0}))),x(window,"message",Ct),x(window,"readystatechange",Pt),Pt());try{top?.document?.getElementById("banner")&&(Ze={},window.mockMsgListener=At,N(window,"message",Ct),define([],(()=>At)))}catch(e){}}()}();
